<template>
  <div id="Recipe">
    <v-card v-if="!recipe">
      <v-card-text>Chargement en cours</v-card-text>
    </v-card>
    <v-card id="recipe" v-else class="mx-auto" tile>
      <v-img class="white--text align-end text-center" height="200px" src="https://www.frenchguycooking.com/wp-content/uploads/2015/03/French-Guy-Cooking-YouTube-Channel-Background-Art-copy.jpg" gradient="to bottom, rgba(0,0,0,.1), rgba(0,0,0,.5)" max-height="200px">
        <v-col class="text-right">
          <v-btn top right small color="secondary" class="v-btn--example mr-2" v-if="connectedUser" @click="addIngredientsToShoppingList">
            <v-icon>mdi-publish</v-icon>
            Ajouter à votre liste de course
          </v-btn>
          <v-btn top right small color="secondary" class="v-btn--example" @click="printRecipe">
            <v-icon>mdi-printer</v-icon>
          </v-btn>
        </v-col>
        <v-card-title>
          <h2 class="mx-auto font-styled">{{recipe.Title}}</h2>
        </v-card-title>
        <v-card-subtitle class="white--text">
          <h3>{{recipe.User.Fullname}}</h3>
          <span v-if="recipe.Comment"> {{recipe.Comment}}</span><br />
          <span class="white--text">
            <i class="fa fa-clock mr-1" /> {{recipe.Duration | milliSecondsToDisplayTime}}
          </span>
        </v-card-subtitle>
      </v-img>
      <v-container fluid>
        <v-row dense>
          <v-col sm="12" md="3">
            <RecipeIngredientsList :ingredients="recipe.RecipeIngredients" />
          </v-col>
          <v-col sm="12" md="9">
            <v-list disabled>
              <v-subheader>Etapes</v-subheader>
              <v-list-item-group color="primary">
                <v-list-item v-for="(step) in recipe.RecipeSteps" :key="step.Order">
                  <v-list-item-avatar class="list-item">
                    {{step.Order}}
                  </v-list-item-avatar>
                  <v-list-item-content>
                    {{step.Text}}
                  </v-list-item-content>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-col>
        </v-row>
      </v-container>
    </v-card>
  </div>
</template>


<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import { Prop, Watch } from "vue-property-decorator";
import RecipeService from "../../services/RecipeService";
import Recipe from "../../transport/Recipe";
import { milliSecondsToDisplayTime } from "../../mixins/GlobalMixins";
import ShoppingListService from "../../services/ShoppingListService";
import RecipeIngredientsList from "./components/RecipeIngredientsList.vue";

@Component({
  components: {
    RecipeIngredientsList,
  },
})
export default class DisplayRecipe extends Vue {
  @Prop(String) private id: string;
  private recipe: Recipe = null;
  private shoppingListService: ShoppingListService = null;

  mounted() {
    this.getRecipeOrRedirect(this.id);
    this.shoppingListService = new ShoppingListService();
  }

  @Watch("id")
  onIdChange(val) {
    this.getRecipeOrRedirect(val);
  }

  get connectedUser() {
    return this.$store.state.connectedUser;
  }

  getRecipeOrRedirect(id: string) {
    new RecipeService().getOneRecipeById(parseInt(id)).then(res => {
      if (res) {
        this.recipe = res;
      } else this.$router.push("Home");
    });
  }
  addIngredientsToShoppingList() {
    this.shoppingListService
      .addRecipeToShoppingList(this.connectedUser.Id, parseInt(this.id))
      .then(res => {
        this.Toast.success(
          "Les ingrédients de la recette ont bien été ajoutés à votre liste de courses."
        );
      });
  }
  printRecipe() {
    this.$htmlToPaper("recipe");
  }
}
</script>
